/*
	preloader.as
	Used to preload movies from frame one. Classes are set to export on frame two
	and this is on frame one so it is not a class.
*/

// Declare the loader assets.
var right:MovieClip;
var middle:MovieClip;
var left:MovieClip;
var track:MovieClip;

// Maxiumum width of the middle piece.
var middleMaxWidth:Number;

function init():Void
{
	middleMaxWidth = track._width - right._width;
	
	// Monitor the loading progress of the parent movie.
	onEnterFrame = function()
	{
		var bl = _parent.home.getBytesLoaded();
		var bt = _parent.home.getBytesTotal();

		if (bl > 4 && bt > 4 && bl >= bt)	// Loading is complete.
		{
			delete onEnterFrame;
			_parent.home.gotoAndPlay(0);
			_parent.gotoAndStop(2);
			this.unloadMovie();
		}
		else
		{
			middle._width = Math.round(bl / bt * middleMaxWidth);
			right._x = middle._x + middle._width;
		}
	}
}

init();
